#pragma once


#define ENVELOPE_CLASS(ENVELOPE,LETTER) \
  \
	ENVELOPE(const LETTER* const aLetterP); \
  \
	ENVELOPE(const Expr& rhs); \
	LETTER* operator->() const; \
	LETTER* getRep () const;



#define ENVELOPE_CODE(ENVELOPE,LETTER) \
 \
ENVELOPE::ENVELOPE(const LETTER* const aLetterP) { \
\
	setRep(((ExprRep*)(aLetterP)));\
}\
\
ENVELOPE::ENVELOPE(const Expr& rhs) {\
\
	LETTER* rhsRep = dynamic_cast<LETTER*>(rhs.getRep());\
	setRep(reinterpret_cast<ExprRep*>(rhsRep));\
}\
\
LETTER* ENVELOPE::operator->() const {\
	return getRep ();\
}\
\
\
LETTER* ENVELOPE::getRep () const {\
	return reinterpret_cast<LETTER*>(Expr::getRep());\
}

