#pragma once

#include <iostream>

#include "Ring.h"
#include "RingMap.h"

class RingProd
{

public:

	RingProd(const Ring& arA, const Ring& arB): rA(arA), rB(arB) {};

	~RingProd(void);

	Ring getRingA () const { return rA; };
	Ring getRingB () const { return rB; };

	RingMap getMapA () const { return mapA; };
	RingMap getMapB () const { return mapB; };

	RingProd(void);


private:

	Ring rA;
	Ring rB;

	Ring rC;

	RingMap mapA;
	RingMap mapB;

};


std::ostream& operator<< (std::ostream& os, const RingProd& rProd);