
#include "stdafx.h"

#include "RingRep.h"
#include "VarList.h"

#include "RingProd.h"

#include "PolynomialRep.h"

#include "Integer.h"

RingElem RingRep::unity () {
	
	throw class Undefined ();

}

bool RingRep::eq(const Ring& rB) const {
	throw Undefined ();
}

bool RingRep::eq(const IntegerRing& rB) const {
	throw Undefined ();
}

bool RingRep::eq(const PolynomialRing& rB) const {
	throw Undefined ();
}

RingElem IntegerRingRep::unity () {
	return Integer(1);
}

bool IntegerRingRep::eq(const Ring& rB) const {
	return rB->eq(IntegerRing(this));
}

bool IntegerRingRep::eq(const IntegerRing& rB) const {
	return rB.getRep() == IntegerRing::integerRing.getRep();
}

bool IntegerRingRep::eq(const PolynomialRing& rB) const {
	return false;
}




PolynomialRingRep::PolynomialRingRep(): coefRing(IntegerRing::integerRing), varlist(VarList()) {
}


PolynomialRingRep::~PolynomialRingRep () {
}

Polynomial PolynomialRingRep::makePolynomial(const Symbol& x) {

	PolynomialRep* pr = new PolynomialRep(PolynomialRing(this), x);
	return Polynomial(pr);

}

RingElem PolynomialRingRep::unity () {

	PolynomialRep* pr = new PolynomialRep(PolynomialRing(this));
	return Polynomial(pr);

}

RingProd PolynomialRingRep::commonOverRing (const Ring& rB) const {
		return rB->commonOverRingPolyLeft(PolynomialRing(this));
}

RingProd PolynomialRingRep::commonOverRingPolyLeft (const PolynomialRing& rB) const {
		return RingProd(rB, PolynomialRing(this));
}



void PolynomialRingRep::print(std::ostream &os) const {

	os << getCoefRing() << "[" << getVarList() << "]";

}

bool PolynomialRingRep::eq(const Ring& rB) const {
	return rB->eq(PolynomialRing(this));
}

bool PolynomialRingRep::eq(const IntegerRing& rB) const {
	return false;
}

bool PolynomialRingRep::eq(const PolynomialRing& rB) const {
	bool eqq = (this->getCoefRing() == rB->getCoefRing());
	eqq = eqq && (this->getVarList() == rB->getVarList());
	return eqq;
}


