#pragma once
#include "Expr.h"
#include "ReprClass.h"

class RingMapRep;
class RingMapIntRep;
class RingMapPolyRep;

class RingMap :
	public virtual Expr
{
public:
	RingMap(void);
	~RingMap(void);

ENVELOPE_CLASS(RingMap, RingMapRep)

};



class RingMapInt :
	public RingMap
{
public:
	RingMapInt(void);
	~RingMapInt(void);

ENVELOPE_CLASS(RingMapInt, RingMapIntRep)

};

class RingMapPoly :
	public RingMap
{
public:
	RingMapPoly(void);
	~RingMapPoly(void);

ENVELOPE_CLASS(RingMapPoly, RingMapPolyRep)

};
