#include "StdAfx.h"

#include "RingMap.h"

#include "RingMapRep.h"

#include "RingElem.h"
#include "RingElemRep.h"

RingMapRep::RingMapRep(void)
{
}

RingMapRep::~RingMapRep(void)
{
}

RingElem RingMapRep::apply(const RingElem& re) {
	throw Undefined();
}



RingMapIntRep::RingMapIntRep(void)
{
}

RingMapIntRep::~RingMapIntRep(void)
{
}

RingElem RingMapIntRep::apply(const RingElem& re) {
	return re->applyIntMap(RingMapInt(this));
}


RingMapPolyRep::RingMapPolyRep(void)
{
}

RingMapPolyRep::~RingMapPolyRep(void)
{
}


RingElem RingMapPolyRep::apply(const RingElem& re) {
	return re->applyPolyMap(RingMapPoly(const_cast<RingMapPolyRep*>(this)));
}

