#pragma once
#include "ExprRep.h"

class RingElem;

class RingMapRep :
	public ExprRep
{
public:

	class Undefined {};

	RingMapRep(void);
	~RingMapRep(void);

	virtual RingElem apply(const RingElem& re);

};


class RingMapIntRep :
	public RingMapRep
{
public:
	RingMapIntRep(void);
	~RingMapIntRep(void);

	RingElem apply(const RingElem& re);

};

class RingMapPolyRep :
	public RingMapRep
{
public:
	RingMapPolyRep(void);
	~RingMapPolyRep(void);

	RingElem apply(const RingElem& re);


};
